' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2007                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVX Sample Program
' C_CAO
'
' 쐬 : K.Yakushinji
'
'  : 2007/02/01 
' -----------------------------------------------------------------

Public Class frmMain

    Private m_blnVideoOpened As Boolean         'rfIfoCXI[vĂ邩
    Private m_strVideoConfFilePath As String    'rfIݒt@CitpXj
    Private m_bIsFreerun As Boolean             't[ǂ

    Private Sub frmMain_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        'rfIfoCX̃I[vԕێϐ̏
        m_blnVideoOpened = False
        btnGrab.Enabled = False
        btnFreerun.Enabled = False

        'gp̊mF
        If My.Forms.frmLicence.ShowDialog() <> Windows.Forms.DialogResult.Yes Then
            End
        End If

        'rfIfoCXI
        setVideoConfFile()

    End Sub

    'rfIݒt@CđI
    Private Sub setVideoConfFile()

        Dim intCaptureType As Integer
        Dim frmVideoConf As New frmSelectVideoConfFile  'rfIݒt@C

        'rfIݒt@C̑I
        m_strVideoConfFilePath = ""
        If frmVideoConf.ShowDialog() = Windows.Forms.DialogResult.OK Then
            m_strVideoConfFilePath = frmVideoConf.strVideoConfFilePath
        End If

        Try
            If m_strVideoConfFilePath.Length <> 0 Then

                If m_blnVideoOpened = True Then
                    'rfIfoCXI[vĂꍇ͈UN[Y܂
                    AxFvxVideo_Aval1.CloseDevice()
                End If

                'rfIfoCX̃I[vԕێϐ̏
                m_blnVideoOpened = False
                btnGrab.Enabled = False
                btnFreerun.Enabled = False

                'rfIݒt@CR|[lgɐݒ
                AxFvxVideo_Aval1.VideoConfFile = m_strVideoConfFilePath
                'foCXI[v
                AxFvxVideo_Aval1.OpenDevice()

                'GrabSync/GrabASync\bhłImegeTCY̕ύXs܂̂ŁA
                '炩ChangeImageSize\bhɂImagẽTCYύXĂ
                'i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
                AxFvxVideo_Aval1.ChangeImageSize(AxFvxImage1.GetOcx())

                'rfIfoCX̏ԂL
                m_blnVideoOpened = True
                btnGrab.Enabled = True
                btnFreerun.Enabled = True

                'gK[h
                cmbTrigger.Items.Clear()
                cmbTrigger.Items.Add("m[}")
                cmbTrigger.Items.Add("gK(SW)")
                cmbTrigger.Items.Add("OgK(Ext)")
                cmbTrigger.SelectedIndex = 0

                '̃gK[h̎擾
                AxFvxVideo_Aval1.GetCaptureType(intCaptureType)
                If 12 = intCaptureType Then
                    cmbTrigger.Enabled = False
                Else
                    cmbTrigger.Enabled = True
                End If

            End If

        Catch

            Dim intErr As Integer
            'G[
            AxFvxVideo_Aval1.GetErrReport(intErr)
            MsgBox(GetFvxVideo_AvalErrMsg(intErr), vbExclamation, "G[")

        Finally

            'ʂ̐
            AxFvxDisplayEx1.CreateDisplay()
            '摜\
            AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

        End Try

    End Sub

    Private Sub frmMain_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        If m_blnVideoOpened = True Then
            'rfIfoCXI[vĂꍇ̓N[Y܂
            AxFvxVideo_Aval1.CloseDevice()
        End If

    End Sub

    Private Sub btnGrab_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGrab.Click

        Dim dblTime As Double

        btnGrab.Enabled = False

        Try
            AxFvxPerformanceCounter1.StartCount()           'ԑJn
            AxFvxVideo_Aval1.GrabSync(AxFvxImage1.GetOcx()) '捞
            AxFvxPerformanceCounter1.StopCount(dblTime)     'ԑI

        Catch

            'G[
            Dim intErr As Integer
            AxFvxVideo_Aval1.GetErrReport(intErr)
            MsgBox("捞G[ " + GetFvxVideo_AvalErrMsg(intErr), MsgBoxStyle.OkOnly Or MsgBoxStyle.Information, "G[")

        Finally

            '荞񂾉摜ʂɕ\
            AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())
            txtGrabTime.Text = dblTime.ToString("0.00ms")
            btnGrab.Enabled = True

        End Try

    End Sub

    'FvxVideo_AvalG[bZ[W擾
    Private Function GetFvxVideo_AvalErrMsg(ByVal intErr As Integer) As String

        Select Case (intErr)
            Case 10001
                GetFvxVideo_AvalErrMsg = "G[łB"
            Case 10002
                GetFvxVideo_AvalErrMsg = "̃\bg̓T|[gĂ܂B"
            Case 10005
                GetFvxVideo_AvalErrMsg = "p[^słB"
            Case 10006
                GetFvxVideo_AvalErrMsg = "C^[tFCXsłB"
            Case 10007
                GetFvxVideo_AvalErrMsg = "{[h̃fBbvXCb`ԈĂ܂B"
            Case 10010
                GetFvxVideo_AvalErrMsg = "̊mۂɎs܂B"
            Case 10020
                GetFvxVideo_AvalErrMsg = "foCX̃I[vɎs܂B"
            Case 10021
                GetFvxVideo_AvalErrMsg = "foCXɃI[vĂ܂B"
            Case 10022
                GetFvxVideo_AvalErrMsg = "foCXI[vĂ܂B"
            Case 10030
                GetFvxVideo_AvalErrMsg = "Lv`I[vĂ܂B"
            Case 10033
                GetFvxVideo_AvalErrMsg = "foCX̃N[YɎs܂B"
            Case 10035
                GetFvxVideo_AvalErrMsg = "ȕ␳Ɏs܂B"
            Case 10037
                GetFvxVideo_AvalErrMsg = "AccessLock|Ă܂B"
            Case 10040
                GetFvxVideo_AvalErrMsg = "摜͂Ɏs܂B"
            Case 10041
                GetFvxVideo_AvalErrMsg = "^CAEg܂B"
            Case 10042
                GetFvxVideo_AvalErrMsg = "摜񂪃Jƈv܂B"
            Case 10043
                GetFvxVideo_AvalErrMsg = "摜͒̂ߐݒύXł܂B"
            Case 10050
                GetFvxVideo_AvalErrMsg = "rfI̓`l̕ύXɎs܂B"
            Case 10070
                GetFvxVideo_AvalErrMsg = "JM̐ݒɎs܂B"
            Case 10072
                GetFvxVideo_AvalErrMsg = "J̓[h̐ݒɎs܂B"
            Case 10074
                GetFvxVideo_AvalErrMsg = "gK̐ݒɎs܂B"
            Case 10080
                GetFvxVideo_AvalErrMsg = "p[^t@C܂B"
            Case 10081
                GetFvxVideo_AvalErrMsg = "t@CpXZbgĂȂA܂̓pX̕܂"
            Case Else
                GetFvxVideo_AvalErrMsg = "sȃG["
        End Select

    End Function

    't[JnE~
    Private Sub btnFreerun_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFreerun.Click
        If m_bIsFreerun Then
            Timer1.Enabled = False
            btnGrab.Enabled = True
            btnFreerun.Text = "Freerun"
        Else
            Timer1.Interval = 100
            Timer1.Start()
            btnGrab.Enabled = False
            btnFreerun.Text = "Stop"
        End If

        m_bIsFreerun = Not m_bIsFreerun
        Application.DoEvents()
    End Sub

    't[
    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim dblTime As Double

        Timer1.Stop()

        Try
            If m_blnVideoOpened Then
                AxFvxPerformanceCounter1.StartCount()
                '捞
                AxFvxVideo_Aval1.GrabSync(AxFvxImage1.GetOcx())
                AxFvxPerformanceCounter1.StopCount(dblTime)
            End If

            Timer1.Enabled = True
        Catch

            Dim intErr As Integer
            AxFvxVideo_Aval1.GetErrReport(intErr)
            MsgBox("捞G[ " + GetFvxVideo_AvalErrMsg(intErr), vbExclamation, "G[")
            Timer1.Enabled = False
            btnGrab.Enabled = True
            btnFreerun.Text = "Freerun"
            m_bIsFreerun = False
        Finally

            '摜\
            AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())
            txtGrabTime.Text = dblTime.ToString("0.00ms")
        End Try
    End Sub

    'gK[h̕ύX
    Private Sub cmbTrigger_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbTrigger.SelectedIndexChanged
        If m_blnVideoOpened Then
            AxFvxVideo_Aval1.SetTrigger(cmbTrigger.SelectedIndex)
        End If
    End Sub

    '\{Plus
    Private Sub btnDispPlus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDispPlus.Click

        AxFvxDisplayEx1.Magnification = AxFvxDisplayEx1.Magnification + +0.1
        If AxFvxDisplayEx1.Magnification > 4.0# Then
            btnDispPlus.Enabled = False
        Else
            btnDispPlus.Enabled = True
        End If
        btnDispMinus.Enabled = True

    End Sub

    '\{minus
    Private Sub btnDispMinus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDispMinus.Click

        AxFvxDisplayEx1.Magnification = AxFvxDisplayEx1.Magnification - 0.1
        If AxFvxDisplayEx1.Magnification < 0.5 Then
            btnDispMinus.Enabled = False
        Else
            btnDispMinus.Enabled = True
        End If
        btnDispPlus.Enabled = True

    End Sub

    '{\
    Private Sub btnDisp1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDisp1.Click
        AxFvxDisplayEx1.Magnification = 1

        btnDispPlus.Enabled = True
        btnDispMinus.Enabled = True

    End Sub

    'tʕ\
    Private Sub btnDispFull_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDispFull.Click

        Dim dblScaleX As Double
        Dim dblScaleY As Double

        dblScaleX = AxFvxDisplayEx1.Size.Width / AxFvxImage1.ImageWidth
        dblScaleY = AxFvxDisplayEx1.Size.Height / AxFvxImage1.ImageHeight

        If dblScaleX < dblScaleY Then
            AxFvxDisplayEx1.Magnification = dblScaleX
        Else
            AxFvxDisplayEx1.Magnification = dblScaleY
        End If

        btnDispPlus.Enabled = True
        btnDispMinus.Enabled = True

    End Sub

    'AScope\؂ւ
    Private Sub chkAScope_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkAScope.CheckedChanged

        If chkAScope.Checked Then
            AxFvxDisplayEx1.AScopeMode = FVXCOMDISPLAYEXLib.DISPLAYEX_ASCOPE_MODE.DISPLAYEX_AScopeAuto
        Else
            AxFvxDisplayEx1.AScopeMode = FVXCOMDISPLAYEXLib.DISPLAYEX_ASCOPE_MODE.DISPLAYEX_AScopeDisable
        End If

    End Sub

    Private Sub btnResetVideoConfFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnResetVideoConfFile.Click

        't[Ȃ΁A~B
        If m_bIsFreerun Then
            Timer1.Enabled = False
            btnGrab.Enabled = True
            btnFreerun.Text = "Freerun"
            m_bIsFreerun = False
        End If

        'rfIfoCX̑I
        setVideoConfFile()

    End Sub

    '\摜ۑ
    Private Sub btnSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveImage.Click

        SaveFileDialog1.InitialDirectory = Application.StartupPath
        SaveFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        SaveFileDialog1.DefaultExt = "*.bmp"
        SaveFileDialog1.ShowDialog()

        If SaveFileDialog1.FileName.Length > 0 Then
            'FvxFileAccesspFvxImaget@Cɕۑ
            AxFvxFileAccess1.FilePath = SaveFileDialog1.FileName()

            Try
                AxFvxFileAccess1.SaveBitmap(AxFvxImage1.GetOcx())
            Catch
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("ۑɎs܂B(ErrCode=" + intErr.ToString() + ")", vbExclamation, "ۑs")
            End Try
        End If

    End Sub
End Class
